'use client';
import { useState } from 'react';
import { useGraphQlBuildAddressesList } from '@/pages/build-address/queries';
import { BuildAddressDataTableUpdate } from '@/pages/build-address/update/table/data-table';
import { BuildAddressForm } from '@/pages/build-address/update/form';
import { useSearchParams, useRouter } from 'next/navigation'
import { Button } from '@/components/ui/button';

const PageUpdateBuildAddress = () => {
    const [page, setPage] = useState(1);
    const [limit, setLimit] = useState(10);
    const [sort, setSort] = useState({ createdAt: 'desc' });
    const [filters, setFilters] = useState({});
    const searchParams = useSearchParams()
    const router = useRouter()
    const uuid = searchParams?.get('uuid') || null
    const backToBuildAddress = <>
        <div>UUID not found in search params</div>
        <Button onClick={() => router.push('/build-address')}>Back to Build Address</Button>
    </>
    if (!uuid) { return backToBuildAddress }
    const { data, isLoading, error, refetch } = useGraphQlBuildAddressesList({ limit, skip: (page - 1) * limit, sort, filters: { ...filters, uuid } });
    const initData = data?.data?.[0] || null;
    if (!initData) { return backToBuildAddress }
    return (
        <>
            <BuildAddressDataTableUpdate
                data={data?.data || []} totalCount={data?.totalCount || 0} currentPage={page} pageSize={limit}
                onPageChange={setPage} onPageSizeChange={setLimit} refetchTable={refetch}
            />
            <BuildAddressForm refetchTable={refetch} initData={initData} selectedUuid={uuid} />
        </>
    )
}

export { PageUpdateBuildAddress };
